//+------------------------------------------------------------------+
//|                                                     VSI_twin.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DarkKhaki
#property indicator_color2  Gold
#property indicator_color3  MediumBlue
#property indicator_color4  FireBrick
#property indicator_level1 0
//----
extern int PeriodF   =14;
extern int PeriodS   =55;
extern double StDv = 1.4;
double vsiBufferUp[];
double vsiBufferDw[];
double vsiBufferFast[];
double vsiBufferSlow[];
double BandUp[];
double BandDw[];
double avg, sDev;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  int init() 
  {
   IndicatorDigits(Digits);
   IndicatorBuffers(6);
   string vsiTitle="VSI_twin";
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE,2);
   SetIndexStyle(3,DRAW_LINE,2);
   SetIndexBuffer(0, vsiBufferFast);
   SetIndexBuffer(1, vsiBufferSlow);
   SetIndexBuffer(2, BandUp);
   SetIndexBuffer(3, BandDw);
   SetIndexBuffer(4, vsiBufferUp);
   SetIndexBuffer(5, vsiBufferDw);
   SetIndexLabel(0,"Fast");
   SetIndexLabel(1,"Slow");
   IndicatorShortName(vsiTitle);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  int start() 
  {
   int i,limit,timeDiff,Error; 
   int counted_bars=IndicatorCounted();
       i=Bars-counted_bars -1;
   int limit1 =Bars-counted_bars;
   int limit2=limit1;
   int limit3=limit1;
   if (limit1>1) {
      limit1 = Bars-1;
      limit2 = limit1-PeriodS;
      limit3 = limit2-1;
   }
     for (i = limit1;i>=0;i--)
   {
         //Difference between the current time and the bar start
         timeDiff=TimeCurrent() - Time[i];
    if(i==0 && timeDiff > 0)
     { 
      if(Close[i]-Open[i]>=0.0)       
      vsiBufferUp[i] = ((Volume[i]-(Close[i]-Open[i])/Point)/2.0+(Close[i]-Open[i])/Point)/timeDiff;
      else
      vsiBufferUp[i] = (Volume[i]+(Close[i]-Open[i])/Point)/2.0/timeDiff;
      if(Close[i]-Open[i]<0.0)       
      vsiBufferDw[i] = ((Volume[i]+(Close[i]-Open[i])/Point)/2.0-(Close[i]-Open[i])/Point)/timeDiff;
      else
      vsiBufferDw[i] = (Volume[i]-(Close[i]-Open[i])/Point)/2.0/timeDiff;
     }
    else
     {
      if(Close[i]-Open[i]>=0.0)       
      vsiBufferUp[i] = ((Volume[i]-(Close[i]-Open[i])/Point)/2.0+(Close[i]-Open[i])/Point)/(Time[i - 1] - Time[i]);
      else
      vsiBufferUp[i] = (Volume[i]+(Close[i]-Open[i])/Point)/2.0/(Time[i - 1] - Time[i]);
      if(Close[i]-Open[i]<0.0)       
      vsiBufferDw[i] = ((Volume[i]+(Close[i]-Open[i])/Point)/2.0-(Close[i]-Open[i])/Point)/(Time[i - 1] - Time[i]);
      else
      vsiBufferDw[i] = (Volume[i]-(Close[i]-Open[i])/Point)/2.0/(Time[i - 1] - Time[i]);
    }
  }
    for (i = limit2;i>=0;i--) 
     {
      vsiBufferFast[i]=iMAOnArray(vsiBufferUp, Bars, PeriodF, 0, MODE_EMA, i)-
                      iMAOnArray(vsiBufferDw, Bars, PeriodF, 0, MODE_EMA, i);
      vsiBufferSlow[i]=iMAOnArray(vsiBufferUp, Bars, PeriodS, 0, MODE_EMA, i)-
                      iMAOnArray(vsiBufferDw, Bars, PeriodS, 0, MODE_EMA, i);
     }
    for (i = limit3;i>=0;i--){
       avg = iMAOnArray(vsiBufferFast, 0, PeriodS, 0, MODE_EMA, i);
       sDev = iStdDevOnArray(vsiBufferFast, 0, PeriodS, 0, MODE_EMA, i);
       BandUp[i] = avg + (StDv * sDev);  // Upperband 
       BandDw[i] = avg - (StDv * sDev);  // Lowerband
   }         
   Error=GetLastError();
   if(Error!=0 && Error!=1) {Print("Error START : ",Error);RefreshRates();}
   return(0);
  }
//+------------------------------------------------------------------+